/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2019 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: stsn_lps25hb.h 001 2019-02-07 20:37:31Z roi $
 */
/**
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT(c) 2016 STMicroelectronics</center></h2>
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

#ifndef _STSN_LIS3MDL_H_
#define _STSN_LIS3MDL_H_

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "device.h"

#ifdef __cplusplus
 extern "C" {
#endif



/************** I2C Address *****************/

#define LIS3MDL_MAG_I2C_ADDRESS_LOW   0x38    // SAD[1] = 0
#define LIS3MDL_MAG_I2C_ADDRESS_HIGH  0x3C    // SAD[1] = 1

/************** Who am I  *******************/

#define LIS3MDL_MAG_WHO_AM_I         0x3D

/************** Device Register  *******************/
#define LIS3MDL_MAG_WHO_AM_I_REG    0X0F
#define LIS3MDL_MAG_CTRL_REG1   0X20
#define LIS3MDL_MAG_CTRL_REG2   0X21
#define LIS3MDL_MAG_CTRL_REG3   0X22
#define LIS3MDL_MAG_CTRL_REG4   0X23
#define LIS3MDL_MAG_CTRL_REG5   0X24
#define LIS3MDL_MAG_STATUS_REG    0X27
#define LIS3MDL_MAG_OUTX_L    0X28
#define LIS3MDL_MAG_OUTX_H    0X29
#define LIS3MDL_MAG_OUTY_L    0X2A
#define LIS3MDL_MAG_OUTY_H    0X2B
#define LIS3MDL_MAG_OUTZ_L    0X2C
#define LIS3MDL_MAG_OUTZ_H    0X2D
#define LIS3MDL_MAG_TEMP_OUT_L    0X2E
#define LIS3MDL_MAG_TEMP_OUT_H    0X2F
#define LIS3MDL_MAG_INT_CFG   0X30
#define LIS3MDL_MAG_INT_SRC   0X31
#define LIS3MDL_MAG_INT_THS_L   0X32
#define LIS3MDL_MAG_INT_THS_H   0X33


/*******************************************************************************
* Register      : WHO_AM_I_REG
* Address       : 0X0F
* Bit Group Name: WHO_AM_I_BIT
* Permission    : RO
*******************************************************************************/
#define   LIS3MDL_MAG_WHO_AM_I_BIT_MASK   0xFF
#define   LIS3MDL_MAG_WHO_AM_I_BIT_POSITION   0

/*******************************************************************************
* Register      : CTRL_REG3
* Address       : 0X22
* Bit Group Name: MD
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LIS3MDL_MAG_MD_CONTINUOUS      = 0x00,
  LIS3MDL_MAG_MD_SINGLE      = 0x01,
  LIS3MDL_MAG_MD_POWER_DOWN      = 0x02,
  LIS3MDL_MAG_MD_POWER_DOWN_AUTO     = 0x03,
} LIS3MDL_MAG_MD_t;

#define   LIS3MDL_MAG_MD_MASK   0x03

/*******************************************************************************
* Register      : CTRL_REG5
* Address       : 0X24
* Bit Group Name: BDU
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LIS3MDL_MAG_BDU_DISABLE      = 0x00,
  LIS3MDL_MAG_BDU_ENABLE     = 0x40,
} LIS3MDL_MAG_BDU_t;

#define   LIS3MDL_MAG_BDU_MASK    LIS3MDL_MAG_BDU_ENABLE

/*******************************************************************************
* Register      : CTRL_REG2
* Address       : 0X21
* Bit Group Name: FS
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LIS3MDL_MAG_FS_4Ga     = 0x00,
  LIS3MDL_MAG_FS_8Ga     = 0x20,
  LIS3MDL_MAG_FS_12Ga      = 0x40,
  LIS3MDL_MAG_FS_16Ga      = 0x60,
} LIS3MDL_MAG_FS_t;

#define   LIS3MDL_MAG_FS_MASK   0x60

/*******************************************************************************
* Register      : CTRL_REG1
* Address       : 0X20
* Bit Group Name: DO
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LIS3MDL_MAG_DO_0_625Hz     = 0x00,
  LIS3MDL_MAG_DO_1_25Hz      = 0x04,
  LIS3MDL_MAG_DO_2_5Hz     = 0x08,
  LIS3MDL_MAG_DO_5Hz     = 0x0C,
  LIS3MDL_MAG_DO_10Hz      = 0x10,
  LIS3MDL_MAG_DO_20Hz      = 0x14,
  LIS3MDL_MAG_DO_40Hz      = 0x18,
  LIS3MDL_MAG_DO_80Hz      = 0x1C,
} LIS3MDL_MAG_DO_t;

#define   LIS3MDL_MAG_DO_MASK   0x1C

/*******************************************************************************
* Register      : CTRL_REG1
* Address       : 0X20
* Bit Group Name: OM
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LIS3MDL_MAG_OM_LOW_POWER     = 0x00,
  LIS3MDL_MAG_OM_MEDIUM      = 0x20,
  LIS3MDL_MAG_OM_HIGH      = 0x40,
  LIS3MDL_MAG_OM_ULTRA_HIGH      = 0x60,
} LIS3MDL_MAG_OM_t;

#define   LIS3MDL_MAG_OM_MASK   0x60

/*******************************************************************************
* Register      : CTRL_REG1
* Address       : 0X20
* Bit Group Name: TEMP_EN
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LIS3MDL_MAG_TEMP_EN_DISABLE    = 0x00,
  LIS3MDL_MAG_TEMP_EN_ENABLE     = 0x80,
} LIS3MDL_MAG_TEMP_EN_t;

#define   LIS3MDL_MAG_TEMP_EN_MASK    0x80

/*******************************************************************************
* Register      : STATUS_REG
* Address       : 0X27
* Bit Group Name: ZYXDA
* Permission    : RO
*******************************************************************************/
typedef enum
{
  LIS3MDL_MAG_ZYXDA_NOT_AVAILABLE  = 0x00,
  LIS3MDL_MAG_ZYXDA_AVAILABLE      = 0x08,
} LIS3MDL_MAG_ZYXDA_t;

#define   LIS3MDL_MAG_ZYXDA_MASK    0x08


typedef enum
{
  LIS3MDL_0                      /* Default on board. */
} MAGNETO_ID_t;
#define MAGNETO_SENSORS_AUTO	LIS3MDL_0


#define LIS3MDL_SENSORS_MAX_NUM 1



#define LIS3MDL_MAG_SENSITIVITY_FOR_FS_4G   0.14  /**< Sensitivity value for 4 gauss full scale [mgauss/LSB] */
#define LIS3MDL_MAG_SENSITIVITY_FOR_FS_8G   0.29  /**< Sensitivity value for 8 gauss full scale [mgauss/LSB] */
#define LIS3MDL_MAG_SENSITIVITY_FOR_FS_12G  0.43  /**< Sensitivity value for 12 gauss full scale [mgauss/LSB] */
#define LIS3MDL_MAG_SENSITIVITY_FOR_FS_16G  0.58  /**< Sensitivity value for 16 gauss full scale [mgauss/LSB] */



extern ER stsn_lis3mdl_init( MAGNETO_ID_t id, void **handle);
extern ER stsn_lis3mdl_deinit(SensContext_t **handle);
extern ER stsn_lis3mdl_sensor_enable(SensContext_t *handle);
extern ER stsn_lis3mdl_sensor_disable(SensContext_t *handle);
extern ER stsn_lis3mdl_isinitialized(SensContext_t *handle, uint8_t *status);
extern ER stsn_lis3mdl_isenabled(SensContext_t *handle, uint8_t *status);
extern ER stsn_lis3mdl_iscombo(SensContext_t *handle, uint8_t *status);
extern ER stsn_lis3mdl_get_instance(SensContext_t *handle, uint8_t *instance);
extern ER stsn_lis3mdl_get_whoamI(SensContext_t *handle, uint8_t *who_am_i);
extern ER stsn_lis3mdl_check_whoamI(SensContext_t *handle);
extern ER stsn_lis3mdl_get_axes(SensContext_t *handle, SensorAxes_t *magnetic_field);
extern ER stsn_lis3mdl_get_axesraw(SensContext_t *handle, SensorAxesRaw_t *value);
extern ER stsn_lis3mdl_get_sensitivity(SensContext_t *handle, float *sensitivity);
extern ER stsn_lis3mdl_get_temperature(SensContext_t *handle, uint8_t *buff);
extern ER stsn_lis3mdl_get_odr(SensContext_t *handle, float *odr );
extern ER stsn_lis3mdl_set_odr(SensContext_t *handle, SensorOdr_t odr );
extern ER stsn_lis3mdl_set_odr_value(SensContext_t *handle, float odr );
extern ER stsn_lis3mdl_get_fs(SensContext_t *handle, float *fullScale);
extern ER stsn_lis3mdl_set_fs(SensContext_t *handle, SensorFs_t fullScale);
extern ER stsn_lis3mdl_set_fs_value(SensContext_t *handle, float fullScale);
extern ER stsn_lis3mdl_read_reg(SensContext_t *handle, uint8_t reg, uint8_t *data);
extern ER stsn_lis3mdl_write_reg(SensContext_t *handle, uint8_t reg, uint8_t data);
extern ER stsn_lis3mdl_get_drdy_status(SensContext_t *handle, uint8_t *status);


#ifdef __cplusplus
}
#endif

#endif /* _STSN_LIS3MDL_H_ */

