/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2019 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: stsn_hts221.h 001 2019-02-07 20:46:57Z roi $
 */
/**
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT(c) 2016 STMicroelectronics</center></h2>
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

#ifndef _STSN_LSM6DS0_H_
#define _STSN_LSM6DS0_H_

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "device.h"

#ifdef __cplusplus
 extern "C" {
#endif

#include "x_nucleo_iks01a1.h"


/************** I2C Address *****************/

#define LSM6DS0_ACC_GYRO_I2C_ADDRESS_LOW   0xD4  // SAD[0] = 0
#define LSM6DS0_ACC_GYRO_I2C_ADDRESS_HIGH  0xD6  // SAD[0] = 1

/************** Who am I  *******************/

#define LSM6DS0_ACC_GYRO_WHO_AM_I         0x68

/************** Device Register  *******************/
#define LSM6DS0_ACC_GYRO_ACT_THS    0X04
#define LSM6DS0_ACC_GYRO_ACT_DUR    0X05
#define LSM6DS0_ACC_GYRO_INT_GEN_CFG_XL   0X06
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_X_XL   0X07
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_Y_XL   0X08
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_Z_XL   0X09
#define LSM6DS0_ACC_GYRO_INT_GEN_DUR_XL   0X0A
#define LSM6DS0_ACC_GYRO_REFERENCE_G    0X0B
#define LSM6DS0_ACC_GYRO_INT_CTRL   0X0C
#define LSM6DS0_ACC_GYRO_WHO_AM_I_REG   0X0F
#define LSM6DS0_ACC_GYRO_CTRL_REG1_G    0X10
#define LSM6DS0_ACC_GYRO_CTRL_REG2_G    0X11
#define LSM6DS0_ACC_GYRO_CTRL_REG3_G    0X12
#define LSM6DS0_ACC_GYRO_ORIENT_CFG_G   0X13
#define LSM6DS0_ACC_GYRO_INT_GEN_SRC_G    0X14
#define LSM6DS0_ACC_GYRO_OUT_TEMP_L   0X15
#define LSM6DS0_ACC_GYRO_OUT_TEMP_H   0X16
#define LSM6DS0_ACC_GYRO_OUT_X_L_G    0X18
#define LSM6DS0_ACC_GYRO_OUT_X_H_G    0X19
#define LSM6DS0_ACC_GYRO_OUT_Y_L_G    0X1A
#define LSM6DS0_ACC_GYRO_OUT_Y_H_G    0X1B
#define LSM6DS0_ACC_GYRO_OUT_Z_L_G    0X1C
#define LSM6DS0_ACC_GYRO_OUT_Z_H_G    0X1D
#define LSM6DS0_ACC_GYRO_CTRL_REG4    0X1E
#define LSM6DS0_ACC_GYRO_CTRL_REG5_XL   0X1F
#define LSM6DS0_ACC_GYRO_CTRL_REG6_XL   0X20
#define LSM6DS0_ACC_GYRO_CTRL_REG7_XL   0X21
#define LSM6DS0_ACC_GYRO_CTRL_REG8    0X22
#define LSM6DS0_ACC_GYRO_CTRL_REG9    0X23
#define LSM6DS0_ACC_GYRO_CTRL_REG10   0X24
#define LSM6DS0_ACC_GYRO_INT_GEN_SRC_XL   0X26
#define LSM6DS0_ACC_GYRO_STATUS_REG   0X27
#define LSM6DS0_ACC_GYRO_OUT_X_L_XL   0X28
#define LSM6DS0_ACC_GYRO_OUT_X_H_XL   0X29
#define LSM6DS0_ACC_GYRO_OUT_Y_L_XL   0X2A
#define LSM6DS0_ACC_GYRO_OUT_Y_H_XL   0X2B
#define LSM6DS0_ACC_GYRO_OUT_Z_L_XL   0X2C
#define LSM6DS0_ACC_GYRO_OUT_Z_H_XL   0X2D
#define LSM6DS0_ACC_GYRO_FIFO_CTRL    0X2E
#define LSM6DS0_ACC_GYRO_FIFO_SRC   0X2F
#define LSM6DS0_ACC_GYRO_INT_GEN_CFG_G    0X30
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_XH_G   0X31
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_XL_G   0X32
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_YH_G   0X33
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_YL_G   0X34
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_ZH_G   0X35
#define LSM6DS0_ACC_GYRO_INT_GEN_THS_ZL_G   0X36
#define LSM6DS0_ACC_GYRO_INT_GEN_DUR_G    0X37


/*******************************************************************************
* Register      : CTRL_REG1_G
* Address       : 0X10
* Bit Group Name: FS_G
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_FS_G_245dps     = 0x00,
  LSM6DS0_ACC_GYRO_FS_G_500dps     = 0x08,
  LSM6DS0_ACC_GYRO_FS_G_1000dps      = 0x10,
  LSM6DS0_ACC_GYRO_FS_G_2000dps      = 0x18,
} LSM6DS0_ACC_GYRO_FS_G_t;

#define   LSM6DS0_ACC_GYRO_FS_G_MASK    0x18

/*******************************************************************************
* Register      : CTRL_REG1_G
* Address       : 0X10
* Bit Group Name: ODR_G
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_ODR_G_POWER_DOWN      = 0x00,
  LSM6DS0_ACC_GYRO_ODR_G_15Hz      = 0x20,
  LSM6DS0_ACC_GYRO_ODR_G_60Hz      = 0x40,
  LSM6DS0_ACC_GYRO_ODR_G_119Hz     = 0x60,
  LSM6DS0_ACC_GYRO_ODR_G_238Hz     = 0x80,
  LSM6DS0_ACC_GYRO_ODR_G_476Hz     = 0xA0,
  LSM6DS0_ACC_GYRO_ODR_G_952Hz     = 0xC0,
} LSM6DS0_ACC_GYRO_ODR_G_t;

#define   LSM6DS0_ACC_GYRO_ODR_G_MASK   0xE0

/*******************************************************************************
* Register      : CTRL_REG6_XL
* Address       : 0X20
* Bit Group Name: FS_XL
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_FS_XL_2g      = 0x00,
  LSM6DS0_ACC_GYRO_FS_XL_16g     = 0x08,
  LSM6DS0_ACC_GYRO_FS_XL_4g      = 0x10,
  LSM6DS0_ACC_GYRO_FS_XL_8g      = 0x18,
} LSM6DS0_ACC_GYRO_FS_XL_t;

#define   LSM6DS0_ACC_GYRO_FS_XL_MASK   0x18

/*******************************************************************************
* Register      : CTRL_REG6_XL
* Address       : 0X20
* Bit Group Name: ODR_XL
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_ODR_XL_POWER_DOWN     = 0x00,
  LSM6DS0_ACC_GYRO_ODR_XL_10Hz     = 0x20,
  LSM6DS0_ACC_GYRO_ODR_XL_50Hz     = 0x40,
  LSM6DS0_ACC_GYRO_ODR_XL_119Hz      = 0x60,
  LSM6DS0_ACC_GYRO_ODR_XL_238Hz      = 0x80,
  LSM6DS0_ACC_GYRO_ODR_XL_476Hz      = 0xA0,
  LSM6DS0_ACC_GYRO_ODR_XL_952Hz      = 0xC0,
} LSM6DS0_ACC_GYRO_ODR_XL_t;

#define   LSM6DS0_ACC_GYRO_ODR_XL_MASK    0xE0

/*******************************************************************************
* Register      : CTRL_REG8
* Address       : 0X22
* Bit Group Name: BDU
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_BDU_DISABLE     = 0x00,
  LSM6DS0_ACC_GYRO_BDU_ENABLE      = 0x40,
} LSM6DS0_ACC_GYRO_BDU_t;

#define   LSM6DS0_ACC_GYRO_BDU_MASK   0x40

/**************** Advanced Function  *******************/

/*******************************************************************************
* Register      : STATUS_REG
* Address       : 0X27
* Bit Group Name: XLDA
* Permission    : RO
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_XLDA_DOWN     = 0x00,
  LSM6DS0_ACC_GYRO_XLDA_UP     = 0x01,
} LSM6DS0_ACC_GYRO_XLDA_t;

#define   LSM6DS0_ACC_GYRO_XLDA_MASK    0x01

/*******************************************************************************
* Register      : STATUS_REG
* Address       : 0X27
* Bit Group Name: GDA
* Permission    : RO
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_GDA_DOWN      = 0x00,
  LSM6DS0_ACC_GYRO_GDA_UP      = 0x02,
} LSM6DS0_ACC_GYRO_GDA_t;

#define   LSM6DS0_ACC_GYRO_GDA_MASK   0x02

/*******************************************************************************
* Register      : CTRL_REG4
* Address       : 0X1E
* Bit Group Name: XEN_G
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_XEN_G_DISABLE     = 0x00,
  LSM6DS0_ACC_GYRO_XEN_G_ENABLE      = 0x08,
} LSM6DS0_ACC_GYRO_XEN_G_t;

#define   LSM6DS0_ACC_GYRO_XEN_G_MASK   0x08

/*******************************************************************************
* Register      : CTRL_REG4
* Address       : 0X1E
* Bit Group Name: YEN_G
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_YEN_G_DISABLE     = 0x00,
  LSM6DS0_ACC_GYRO_YEN_G_ENABLE      = 0x10,
} LSM6DS0_ACC_GYRO_YEN_G_t;

#define   LSM6DS0_ACC_GYRO_YEN_G_MASK   0x10

/*******************************************************************************
* Register      : CTRL_REG4
* Address       : 0X1E
* Bit Group Name: ZEN_G
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_ZEN_G_DISABLE     = 0x00,
  LSM6DS0_ACC_GYRO_ZEN_G_ENABLE      = 0x20,
} LSM6DS0_ACC_GYRO_ZEN_G_t;

#define   LSM6DS0_ACC_GYRO_ZEN_G_MASK   0x20

/*******************************************************************************
* Register      : CTRL_REG5_XL
* Address       : 0X1F
* Bit Group Name: XEN_XL
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_XEN_XL_DISABLE      = 0x00,
  LSM6DS0_ACC_GYRO_XEN_XL_ENABLE     = 0x08,
} LSM6DS0_ACC_GYRO_XEN_XL_t;

#define   LSM6DS0_ACC_GYRO_XEN_XL_MASK    0x08

/*******************************************************************************
* Register      : CTRL_REG5_XL
* Address       : 0X1F
* Bit Group Name: YEN_XL
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_YEN_XL_DISABLE      = 0x00,
  LSM6DS0_ACC_GYRO_YEN_XL_ENABLE     = 0x10,
} LSM6DS0_ACC_GYRO_YEN_XL_t;

#define   LSM6DS0_ACC_GYRO_YEN_XL_MASK    0x10

/*******************************************************************************
* Register      : CTRL_REG5_XL
* Address       : 0X1F
* Bit Group Name: ZEN_XL
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_ZEN_XL_DISABLE      = 0x00,
  LSM6DS0_ACC_GYRO_ZEN_XL_ENABLE     = 0x20,
} LSM6DS0_ACC_GYRO_ZEN_XL_t;

#define   LSM6DS0_ACC_GYRO_ZEN_XL_MASK    0x20

/*******************************************************************************
* Register      : CTRL_REG8
* Address       : 0X22
* Bit Group Name: IF_ADD_INC
* Permission    : RW
*******************************************************************************/
typedef enum
{
  LSM6DS0_ACC_GYRO_IF_ADD_INC_DISABLE      = 0x00,
  LSM6DS0_ACC_GYRO_IF_ADD_INC_ENABLE     = 0x04,
} LSM6DS0_ACC_GYRO_IF_ADD_INC_t;

#define   LSM6DS0_ACC_GYRO_IF_ADD_INC_MASK    0x04



#define LSM6DS0_SENSORS_MAX_NUM  1     /**< LSM6DS0 max number of instances */


#define LSM6DS0_ACC_SENSITIVITY_FOR_FS_2G   0.061  /**< Sensitivity value for 2 g full scale [mg/LSB] */
#define LSM6DS0_ACC_SENSITIVITY_FOR_FS_4G   0.122  /**< Sensitivity value for 4 g full scale [mg/LSB] */
#define LSM6DS0_ACC_SENSITIVITY_FOR_FS_8G   0.244  /**< Sensitivity value for 8 g full scale [mg/LSB] */
#define LSM6DS0_ACC_SENSITIVITY_FOR_FS_16G  0.732  /**< Sensitivity value for 16 g full scale [mg/LSB] */

/** @addtogroup LSM6DS0_GYRO_SENSITIVITY Gyro sensitivity values based on selected full scale
 * @{
 */

#define LSM6DS0_GYRO_SENSITIVITY_FOR_FS_245DPS   08.75  /**< Sensitivity value for 245 dps full scale [mdps/LSB] */
#define LSM6DS0_GYRO_SENSITIVITY_FOR_FS_500DPS   17.50  /**< Sensitivity value for 500 dps full scale [mdps/LSB] */
#define LSM6DS0_GYRO_SENSITIVITY_FOR_FS_2000DPS  70.00  /**< Sensitivity value for 2000 dps full scale [mdps/LSB] */


typedef struct
{
  float   Previous_ODRX;
  float   Previous_ODRG;
  float   lastGyroODR;
  uint8_t isGyroEnabled;
} LSM6DS0_Data_t;


typedef enum
{
  LSM6DS0_G_0,                   /* Default on board. */
} LSM6DS0_ID_t;
#define GYRO_SENSORS_AUTO	LSM6DS0_G_0

typedef enum
{
  LSM6DS0_X_0                    /* Default on board. */
} ACCELERO_ID_t;
#define ACCELERO_SENSORS_AUTO LSM6DS0_X_0


#define LSM6DS0_SENSORS_MAX_NUM 1


extern ER stsn_lsm6ds0_init(LSM6DS0_ID_t id, void **handle );
extern ER stsn_lsm6ds0_deinit(SensContext_t **handle);
extern ER stsn_lsm6ds0_acci_sensor_enable(SensContext_t *handle);
extern ER stsn_lsm6ds0_gyro_sensor_enable(SensContext_t *handle);
extern ER stsn_lsm6ds0_acci_sensor_disable(SensContext_t *handle);
extern ER stsn_lsm6ds0_gyro_sensor_disable(SensContext_t *handle);
extern ER stsn_lsm6ds0_isinitialized(SensContext_t *handle, uint8_t *status);
extern ER stsn_lsm6ds0_isenabled(SensContext_t *handle, uint8_t *status);
extern ER stsn_lsm6ds0_iscombo(SensContext_t *handle, uint8_t *status);
extern ER stsn_lsm6ds0_get_instance(SensContext_t *handle, uint8_t *instance);
extern ER stsn_lsm6ds0_get_whoamI(SensContext_t *handle, uint8_t *who_am_i);
extern ER stsn_lsm6ds0_check_whoamI(SensContext_t *handle);
extern ER stsn_lsm6ds0_get_acci_axes(SensContext_t *handle, SensorAxes_t *acceleration);
extern ER stsn_lsm6ds0_get_gyro_axes(SensContext_t *handle, SensorAxes_t *angular_velocity);
extern ER stsn_lsm6ds0_get_acci_axesraw(SensContext_t *handle, SensorAxesRaw_t *value);
extern ER stsn_lsm6ds0_get_gyro_axesraw(SensContext_t *handle, SensorAxesRaw_t *value);
extern ER stsn_lsm6ds0_acci_sensitivity(SensContext_t *handle, float *sensitivity);
extern ER stsn_lsm6ds0_gyro_sensitivity(SensContext_t *handle, float *sensitivity);
extern ER stsn_lsm6ds0_get_temperature(SensContext_t *handle, uint8_t *buff);
extern ER stsn_lsm6ds0_get_acci_odr( SensContext_t *handle, float *odr);
extern ER stsn_lsm6ds0_get_gyro_odr(SensContext_t *handle, float *odr);
extern ER stsn_lsm6ds0_set_acci_odr(SensContext_t *handle, SensorOdr_t odr);
extern ER stsn_lsm6ds0_set_gyro_odr(SensContext_t *handle, SensorOdr_t odr);
extern ER stsn_lsm6ds0_set_acci_odr_value(SensContext_t *handle, float odr);
extern ER stsn_lsm6ds0_set_gyro_odr_value(SensContext_t *handle, float odr);
extern ER stsn_lsm6ds0_get_acci_fs(SensContext_t *handle, float *fullScale);
extern ER stsn_lsm6ds0_get_gyro_fs(SensContext_t *handle, float *fullScale);
extern ER stsn_lsm6ds0_set_acci_fs(SensContext_t *handle, SensorFs_t fullScale);
extern ER stsn_lsm6ds0_set_gyro_fs(SensContext_t *handle, SensorFs_t fullScale);
extern ER stsn_lsm6ds0_set_acci_fs_value(SensContext_t *handle, float fullScale);
extern ER stsn_lsm6ds0_set_gyro_fs_value(SensContext_t *handle, float fullScale);
extern ER stsn_lsm6ds0_get_acci_axes_status(SensContext_t *handle, uint8_t *xyz_enabled);
extern ER stsn_lsm6ds0_get_gyro_axes_status(SensContext_t *handle, uint8_t *xyz_enabled);
extern ER stsn_lsm6ds0_set_acci_axes_status(SensContext_t *handle, uint8_t *enable_xyz);
extern ER stsn_lsm6ds0_set_gyro_axes_status(SensContext_t *handle, uint8_t *enable_xyz);
extern ER stsn_lsm6ds0_read_reg(SensContext_t *handle, uint8_t reg, uint8_t *data);
extern ER stsn_lsm6ds0_write_reg(SensContext_t *handle, uint8_t reg, uint8_t data);
extern ER stsn_lsm6ds0_get_drdy_status(SensContext_t *handle, uint8_t *status);

#ifdef __cplusplus
}
#endif

#endif /* _STSN_LSM6DS0_H_ */

