/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: x_nucleo_iks01a1_accelero.h 2416 2019-02-07 21:01:08Z roi $
 */
/**
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT(c) 2017 STMicroelectronics</center></h2>
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

#ifndef __X_NUCLEO_IKS01A1_ACCELERO_H
#define __X_NUCLEO_IKS01A1_ACCELERO_H

#ifdef __cplusplus
extern "C" {
#endif


#include "x_nucleo_iks01a1.h"
#include "stsn_lsm6ds0.h"


/* Sensor Configuration Functions */
#define BSP_ACCELERO_Init               stsn_lsm6ds0_init
#define BSP_ACCELERO_DeInit             stsn_lsm6ds0_deinit
#define BSP_ACCELERO_Sensor_Enable      stsn_lsm6ds0_acci_sensor_enable
#define BSP_ACCELERO_Sensor_Disable     stsn_lsm6ds0_acci_sensor_disable
#define BSP_ACCELERO_IsInitialized      stsn_lsm6ds0_isinitialized
#define BSP_ACCELERO_IsEnabled          stsn_lsm6ds0_isenabled
#define BSP_ACCELERO_IsCombo            stsn_lsm6ds0_iscombo
#define BSP_ACCELERO_Get_Instance       stsn_lsm6ds0_get_instance
#define BSP_ACCELERO_Get_WhoAmI         stsn_lsm6ds0_get_whoamI
#define BSP_ACCELERO_Check_WhoAmI       stsn_lsm6ds0_check_whoamI
#define BSP_ACCELERO_Get_Axes           stsn_lsm6ds0_get_acci_axes
#define BSP_ACCELERO_Get_AxesRaw        stsn_lsm6ds0_get_acci_axesraw
#define BSP_ACCELERO_Get_Sensitivity    stsn_lsm6ds0_acci_sensitivity
#define BSP_ACCELERO_Get_ODR            stsn_lsm6ds0_get_acci_odr
#define BSP_ACCELERO_Set_ODR            stsn_lsm6ds0_set_acci_odr
#define BSP_ACCELERO_Set_ODR_Value      stsn_lsm6ds0_set_acci_odr_value
#define BSP_ACCELERO_Get_FS             stsn_lsm6ds0_get_acci_fs
#define BSP_ACCELERO_Set_FS             stsn_lsm6ds0_set_acci_fs
#define BSP_ACCELERO_Set_FS_Value       stsn_lsm6ds0_get_acci_axes_status
#define BSP_ACCELERO_Get_Axes_Status    stsn_lsm6ds0_get_acci_axes_status
#define BSP_ACCELERO_Set_Axes_Status    stsn_lsm6ds0_set_acci_axes_status
#define BSP_ACCELERO_Read_Reg           stsn_lsm6ds0_read_reg
#define BSP_ACCELERO_Write_Reg          stsn_lsm6ds0_write_reg
#define BSP_ACCELERO_Get_DRDY_Status    stsn_lsm6ds0_get_drdy_status



#ifdef __cplusplus
}
#endif

#endif /* __X_NUCLEO_IKS01A1_ACCELERO_H */

