/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: x_nucleo_iks01a1_magneto.h 2416 2019-02-07 21:06:31Z roi $
 */
/**
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT(c) 2017 STMicroelectronics</center></h2>
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

#ifndef __X_NUCLEO_IKS01A1_MAGNETO_H
#define __X_NUCLEO_IKS01A1_MAGNETO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "x_nucleo_iks01a1.h"
#include "stsn_lis3mdl.h"


/* Sensor Configuration Functions */
#define BSP_MAGNETO_Init                    stsn_lis3mdl_init
#define BSP_MAGNETO_DeInit                  stsn_lis3mdl_deinit
#define BSP_MAGNETO_Sensor_Enable           stsn_lis3mdl_sensor_enable
#define BSP_MAGNETO_Sensor_Disable          stsn_lis3mdl_sensor_disable
#define BSP_MAGNETO_IsInitialized           stsn_lis3mdl_isinitialized
#define BSP_MAGNETO_IsEnabled               stsn_lis3mdl_isenabled
#define BSP_MAGNETO_IsCombo                 stsn_lis3mdl_iscombo
#define BSP_MAGNETO_Get_Instance            stsn_lis3mdl_get_instance
#define BSP_MAGNETO_Get_WhoAmI              stsn_lis3mdl_get_whoamI
#define BSP_MAGNETO_Check_WhoAmI            stsn_lis3mdl_check_whoamI
#define BSP_MAGNETO_Get_Axes                stsn_lis3mdl_get_axes
#define BSP_MAGNETO_Get_AxesRaw             stsn_lis3mdl_get_axesraw
#define BSP_MAGNETO_Get_Sensitivity         stsn_lis3mdl_get_sensitivity
#define BSP_MAGNETO_Get_ODR                 stsn_lis3mdl_get_odr
#define BSP_MAGNETO_Set_ODR                 stsn_lis3mdl_set_odr
#define BSP_MAGNETO_Set_ODR_Value           stsn_lis3mdl_set_odr_value
#define BSP_MAGNETO_Get_FS                  stsn_lis3mdl_get_fs
#define BSP_MAGNETO_Set_FS                  stsn_lis3mdl_set_fs
#define BSP_MAGNETO_Set_FS_Value            stsn_lis3mdl_set_fs_value
#define BSP_MAGNETO_Read_Reg                stsn_lis3mdl_read_reg
#define BSP_MAGNETO_Write_Reg               stsn_lis3mdl_write_reg
#define BSP_MAGNETO_Get_DRDY_Status         stsn_lis3mdl_get_drdy_status

#ifdef __cplusplus
}
#endif

#endif /* __X_NUCLEO_IKS01A1_MAGNETO_H */

